VERSION 5.00
Begin VB.Form frmChooseDirectory 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Choose a directory to search for ROMS"
   ClientHeight    =   2640
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4695
   Icon            =   "frmChooseDirectory.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2640
   ScaleWidth      =   4695
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   2000
      Left            =   360
      Top             =   3240
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   320
      Left            =   2400
      TabIndex        =   2
      Top             =   2280
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   320
      Left            =   1320
      TabIndex        =   1
      Top             =   2280
      Width           =   975
   End
   Begin VB.ListBox List1 
      Height          =   2010
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
   Begin VB.Label lblScreenState 
      Height          =   135
      Left            =   2280
      TabIndex        =   16
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblScreenHeight 
      Height          =   135
      Left            =   2160
      TabIndex        =   15
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblColors 
      Height          =   135
      Left            =   2400
      TabIndex        =   14
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblScreenWidth 
      Height          =   135
      Left            =   2040
      TabIndex        =   13
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath10 
      Height          =   135
      Left            =   1920
      TabIndex        =   12
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath9 
      Height          =   135
      Left            =   1800
      TabIndex        =   11
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath8 
      Height          =   135
      Left            =   1680
      TabIndex        =   10
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath7 
      Height          =   135
      Left            =   1560
      TabIndex        =   9
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath6 
      Height          =   135
      Left            =   1440
      TabIndex        =   8
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath5 
      Height          =   135
      Left            =   1320
      TabIndex        =   7
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath4 
      Height          =   135
      Left            =   1200
      TabIndex        =   6
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath3 
      Height          =   135
      Left            =   1080
      TabIndex        =   5
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath2 
      Height          =   135
      Left            =   960
      TabIndex        =   4
      Top             =   3360
      Width           =   135
   End
   Begin VB.Label lblRomsPath1 
      Height          =   135
      Left            =   840
      TabIndex        =   3
      Top             =   3360
      Width           =   135
   End
End
Attribute VB_Name = "frmChooseDirectory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Sub cmdCancel_Click()
    frmMain.SetFocus
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Dim filename As String
    filename = Open_File()
    CPUPaused = False
    If filename = "" Then Exit Sub
    romName = extractFileName(filename)
    If LoadNES(filename) = 0 Then Exit Sub
    frmMain.StatusBar1.Panels(2).Text = romName + " loaded"
    frmMain.StatusBar1.Refresh
    Dim NESLoop As Integer
    CPURunning = True
    FirstRead = True
    PPU_AddressIsHi = True
    PPUAddress = 0: SpriteAddress = 0: PPU_Status = 0
    PPU_Control1 = 0: PPU_Control2 = 0
    init6502
    frmMain.StatusBar1.Panels(2).Text = romName + " initialized"
    Do Until CPURunning = False
        exec6502
    Loop
End Sub

Private Function extractFileName(p As String) As String
    Dim s As String
    Dim I As Long
    s = p
    Do While InStr(s, "\")
        s = Mid$(s, InStr(s, "\") + 1)
        Debug.Print s
    Loop
    If InStr(s, ".") Then
        s = Left$(s, InStr(s, ".") - 1)
    End If
    Debug.Print s
    extractFileName = s
End Function

Private Sub Form_Load()
    Dim Reg As New cRegistry
    With Reg
        .ClassKey = HKEY_LOCAL_MACHINE
        .SectionKey = "Software\MicroTek Software\MicroTekNES"
        .ValueKey = "ScreenState"
        lblScreenState.Caption = .Value
        .ValueKey = "ScreenWidth"
        lblScreenWidth.Caption = .Value
        .ValueKey = "ScreenHeight"
        lblScreenHeight.Caption = .Value
        .ValueKey = "Colors"
        lblColors.Caption = .Value
        .ValueKey = "RomPath1"
        lblRomsPath1.Caption = .Value
        .ValueKey = "RomPath2"
        lblRomsPath2.Caption = .Value
        .ValueKey = "RomPath3"
        lblRomsPath3.Caption = .Value
        .ValueKey = "RomPath4"
        lblRomsPath4.Caption = .Value
        .ValueKey = "RomPath5"
        lblRomsPath5.Caption = .Value
        .ValueKey = "RomPath6"
        lblRomsPath6.Caption = .Value
        .ValueKey = "RomPath7"
        lblRomsPath7.Caption = .Value
        .ValueKey = "RomPath8"
        lblRomsPath8.Caption = .Value
        .ValueKey = "RomPath9"
        lblRomsPath9.Caption = .Value
        .ValueKey = "RomPath10"
        lblRomsPath10.Caption = .Value
    End With
End Sub

Private Function Open_File() As String
    Dim lReturn As Long
    Dim sFilter As String
    OpenFile.lStructSize = Len(OpenFile)
    OpenFile.hWndOwner = Me.hwnd
    OpenFile.hInstance = App.hInstance
    sFilter = "NES ROMs (*.nes)" & Chr(0) & "*.nes" & Chr(0)
    OpenFile.lpstrFilter = sFilter
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrFile = String(257, 0)
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.lpstrInitialDir = List1.Text
    OpenFile.lpstrTitle = "Open NES ROM"
    OpenFile.flags = 4
    lReturn = GetOpenFileName(OpenFile)
    If lReturn = 0 Then
       Open_File = ""
    Else
       Open_File = OpenFile.lpstrFile
    End If
    frmMain.Picture1.SetFocus
    'If lblScreenState.Caption = "Stretched" Then
    '    ChangeScreen lblScreenWidth, lblScreenHeight, lblColors
    'End If
    Unload Me
End Function

Private Sub Timer1_Timer()
    If lblRomsPath1.Caption <> "" Then
        List1.AddItem (lblRomsPath1.Caption)
    End If
    If lblRomsPath2.Caption <> "" Then
        List1.AddItem (lblRomsPath2.Caption)
    End If
    If lblRomsPath3.Caption <> "" Then
        List1.AddItem (lblRomsPath3.Caption)
    End If
    If lblRomsPath4.Caption <> "" Then
        List1.AddItem (lblRomsPath4.Caption)
    End If
    If lblRomsPath5.Caption <> "" Then
        List1.AddItem (lblRomsPath5.Caption)
    End If
    If lblRomsPath6.Caption <> "" Then
        List1.AddItem (lblRomsPath6.Caption)
    End If
    If lblRomsPath7.Caption <> "" Then
        List1.AddItem (lblRomsPath7.Caption)
    End If
    If lblRomsPath8.Caption <> "" Then
        List1.AddItem (lblRomsPath8.Caption)
    End If
    If lblRomsPath9.Caption <> "" Then
        List1.AddItem (lblRomsPath9.Caption)
    End If
    If lblRomsPath10.Caption <> "" Then
        List1.AddItem (lblRomsPath10.Caption)
    End If
    If List1.Text <> "" Then
        List1.Selected(0) = True
    End If
    Timer1.Enabled = False
End Sub
